//
//
// pilot blink timing for a led in PB2
// with a button in PA7
//

#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>



#define bton_port PORTA
#define led_port PORTB
#define led_direction DDRB
#define button_pins PINA
#define button_pin_in (1 << PA7)
#define led_pin_out (1 << PB2)

#define max_buffer 25


uint16_t blink_delay=1;


// Define long delay function
void long_delay_ms(uint16_t ms) {
    for(ms /= 10; ms>0; ms--) _delay_ms(10);
}


int main(void) {
   //
   // main
   //
   //
   // set clock divider to /1
   //
   CLKPR = (1 << CLKPCE);
   CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
   //
   // initialize  pin s
   //
   DDRB |=led_pin_out;//led out
   PORTA |= button_pin_in;//button pin as pullup

 
   

   //
   // main loop
   while (1) {
    		if (PINA & button_pin_in){//if button not pushed
                PORTB |= led_pin_out; // Turn LED on
                long_delay_ms(blink_delay);
                PORTB &= ~led_pin_out; // Turn LED off
                long_delay_ms(blink_delay);
			}else{//if button pushed
				blink_delay=10;
				while(!(PINA & button_pin_in)){
					blink_delay+=10;
					_delay_ms(10);
				}
				}
		}
   }
